import base64
import json
import math
import threading
import time

from datetime import datetime
from fischertechnik.controller.Motor import Motor
from fischertechnik.mqtt.Client import Client as MqttClient
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from lib.camera import *
from lib.controller import *


impulses_per_degree_pan = None
snapshot = None
ts = None
impulses_per_degree_tilt = None


def Init_Pan():
    global impulses_per_degree_pan, snapshot, ts, impulses_per_degree_tilt
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M1_encodermotor.start_sync()
    while True:
        if (TXT_M_I1_mini_switch.is_closed()):
            break
        time.sleep(0.010)
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(round(87 * impulses_per_degree_pan)))
    while True:
        if (not TXT_M_M1_encodermotor.is_running()):
            break
        time.sleep(0.010)


def Init_Tilt():
    global impulses_per_degree_pan, snapshot, ts, impulses_per_degree_tilt
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M2_encodermotor.start_sync()
    while True:
        if (TXT_M_I2_mini_switch.is_closed()):
            break
        time.sleep(0.010)
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M2_encodermotor.set_distance(int(round(78 * impulses_per_degree_tilt)))
    while True:
        if (not TXT_M_M2_encodermotor.is_running()):
            break
        time.sleep(0.010)


def image_callback(event):
    global impulses_per_degree_pan, snapshot, ts, impulses_per_degree_tilt
    snapshot = "data:image/jpeg;base64," + base64.b64encode(event.value).decode("utf-8")

TXT_M_USB1_1_camera.add_change_listener("image", image_callback)


def datetimestamp():
    global impulses_per_degree_pan, snapshot, ts, impulses_per_degree_tilt
    ts = datetime.now().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3] + "Z"
    return ts


impulses_per_degree_pan = 10.295
impulses_per_degree_tilt = 5.325
snapshot = ''
threading.Thread(target=Init_Pan, daemon=True).start()
threading.Thread(target=Init_Tilt, daemon=True).start()
MqttClient.getInstance().connect()
while True:
    if (MqttClient.getInstance().is_connected()):
        break
    time.sleep(0.010)
while True:
    MqttClient.getInstance().publish("/j1/txt/" + str(CONTROLLER_ID) +"/i/cam", '{{"ts":"{}","data":"{}"}}'.format(datetimestamp(), snapshot))
    time.sleep(1)


